diff --git a/src/doomtype.h b/src/doomtype.h
index df97398d46..73bcb41001 100644
--- a/src/doomtype.h
+++ b/src/doomtype.h
@@ -145,24 +145,11 @@ size_t strlcpy(char *dst, const char *src, size_t siz);
 
 /* Boolean type definition */
 
-// Note: C++ bool and C99/C11 _Bool are NOT compatible.
-// Historically, boolean was win32 BOOL on Windows. For equivalence, it's now
-// int32_t. "true" and "false" are only declared for C code; in C++, conversion
-// between "bool" and "int32_t" takes over.
-#ifndef _WIN32
-typedef int32_t boolean;
-#else
-#define boolean BOOL
+#ifndef bool // backwards compat for older GNU
+#include <stdbool.h>
 #endif
 
-#ifndef __cplusplus
-#ifndef _WIN32
-enum {false = 0, true = 1};
-#else
-#define false FALSE
-#define true TRUE
-#endif
-#endif
+#define boolean bool
 
 /* 7.18.2.1  Limits of exact-width integer types */
 
diff --git a/src/f_finale.c b/src/f_finale.c
index 264c18d531..91ddd70d2b 100644
--- a/src/f_finale.c
+++ b/src/f_finale.c
@@ -2416,14 +2416,12 @@ void F_StartTitleScreen(void)
 
 	if (gamestate != GS_TITLESCREEN && gamestate != GS_WAITINGPLAYERS)
 	{
-		ttuser_count =\
-		 ttloaded[0] = ttloaded[1] = ttloaded[2] = ttloaded[3] = ttloaded[4] = ttloaded[5] =\
-		 testttscale = activettscale =\
-		 sonic_blink = sonic_blink_twice = sonic_idle_start = sonic_idle_end =\
-		 tails_blink = tails_blink_twice = tails_idle_start = tails_idle_end =\
-		 knux_blink  = knux_blink_twice  = knux_idle_start  = knux_idle_end  = 0;
-
-		sonic_blinked_already = tails_blinked_already = knux_blinked_already = 1; // don't blink on the first idle cycle
+		ttuser_count = 0; // note: you cannot mix bool with int when setting these values, lines which set booleans use true/false here
+		ttloaded[0] = ttloaded[1] = ttloaded[2] = ttloaded[3] = ttloaded[4] = ttloaded[5] = false;
+		testttscale = activettscale = sonic_idle_start = tails_idle_start = knux_idle_start = sonic_idle_end = tails_idle_end = knux_idle_end = 0;
+		sonic_blink = sonic_blink_twice = tails_blink = tails_blink_twice = knux_blink  = knux_blink_twice = false;
+
+		sonic_blinked_already = tails_blinked_already = knux_blinked_already = true; // don't blink on the first idle cycle
 
 		if (curttmode == TTMODE_ALACROIX)
 			finalecount = -3; // hack so that frames don't advance during the entry wipe
diff --git a/src/hardware/hw_light.c b/src/hardware/hw_light.c
index 9011ff05ec..f993e8e4ad 100644
--- a/src/hardware/hw_light.c
+++ b/src/hardware/hw_light.c
@@ -1429,7 +1429,7 @@ static void HWR_SearchLightsInMobjs(void)
 
 	// search in the list of thinkers
 	for (th = thlist[THINK_MOBJ].next; th != &thlist[THINK_MOBJ]; th = th->next)
-		if (th->function.acp1 != (actionf_p1)P_RemoveThinkerDelayed)
+		if (th->function != (actionf_p1)P_RemoveThinkerDelayed)
 			HWR_AddMobjLights((mobj_t *)th);
 }
 #endif
diff --git a/src/hardware/hw_main.c b/src/hardware/hw_main.c
index a5befe112c..a36b3a696b 100644
--- a/src/hardware/hw_main.c
+++ b/src/hardware/hw_main.c
@@ -5304,7 +5304,7 @@ static void HWR_SetTransformAiming(FTransform *trans, player_t *player, boolean
 //
 static void HWR_SetShaderState(void)
 {
-	HWD.pfnSetSpecialState(HWD_SET_SHADERS, (INT32)HWR_UseShader());
+	HWD.pfnSetSpecialState(HWD_SET_SHADERS, HWR_UseShader());
 }
 
 static void HWR_SetupView(player_t *player, INT32 viewnumber, float fpov, boolean skybox)
diff --git a/src/info.h b/src/info.h
index 94b0aeb481..b438b21b98 100644
--- a/src/info.h
+++ b/src/info.h
@@ -302,274 +302,274 @@ struct mobj_s;
 
 // IMPORTANT NOTE: If you add/remove from this list of action
 // functions, don't forget to update them in deh_tables.c!
-void A_Explode(struct mobj_s *actor);
-void A_Pain(struct mobj_s *actor);
-void A_Fall(struct mobj_s *actor);
-void A_MonitorPop(struct mobj_s *actor);
-void A_GoldMonitorPop(struct mobj_s *actor);
-void A_GoldMonitorRestore(struct mobj_s *actor);
-void A_GoldMonitorSparkle(struct mobj_s *actor);
-void A_Look(struct mobj_s *actor);
-void A_Chase(struct mobj_s *actor);
-void A_FaceStabChase(struct mobj_s *actor);
-void A_FaceStabRev(struct mobj_s *actor);
-void A_FaceStabHurl(struct mobj_s *actor);
-void A_FaceStabMiss(struct mobj_s *actor);
-void A_StatueBurst(struct mobj_s *actor);
-void A_FaceTarget(struct mobj_s *actor);
-void A_FaceTracer(struct mobj_s *actor);
-void A_Scream(struct mobj_s *actor);
-void A_BossDeath(struct mobj_s *actor);
-void A_SetShadowScale(struct mobj_s *actor);
-void A_ShadowScream(struct mobj_s *actor); // MARIA!!!!!!
-void A_CustomPower(struct mobj_s *actor); // Use this for a custom power
-void A_GiveWeapon(struct mobj_s *actor); // Gives the player weapon(s)
-void A_RingBox(struct mobj_s *actor); // Obtained Ring Box Tails
-void A_Invincibility(struct mobj_s *actor); // Obtained Invincibility Box
-void A_SuperSneakers(struct mobj_s *actor); // Obtained Super Sneakers Box
-void A_BunnyHop(struct mobj_s *actor); // have bunny hop tails
-void A_BubbleSpawn(struct mobj_s *actor); // Randomly spawn bubbles
-void A_FanBubbleSpawn(struct mobj_s *actor);
-void A_BubbleRise(struct mobj_s *actor); // Bubbles float to surface
-void A_BubbleCheck(struct mobj_s *actor); // Don't draw if not underwater
-void A_AwardScore(struct mobj_s *actor);
-void A_ExtraLife(struct mobj_s *actor); // Extra Life
-void A_GiveShield(struct mobj_s *actor); // Obtained Shield
-void A_GravityBox(struct mobj_s *actor);
-void A_ScoreRise(struct mobj_s *actor); // Rise the score logo
-void A_AttractChase(struct mobj_s *actor); // Ring Chase
-void A_DropMine(struct mobj_s *actor); // Drop Mine from Skim or Jetty-Syn Bomber
-void A_FishJump(struct mobj_s *actor); // Fish Jump
-void A_ThrownRing(struct mobj_s *actor); // Sparkle trail for red ring
-void A_SetSolidSteam(struct mobj_s *actor);
-void A_UnsetSolidSteam(struct mobj_s *actor);
-void A_SignSpin(struct mobj_s *actor);
-void A_SignPlayer(struct mobj_s *actor);
-void A_OverlayThink(struct mobj_s *actor);
-void A_JetChase(struct mobj_s *actor);
-void A_JetbThink(struct mobj_s *actor); // Jetty-Syn Bomber Thinker
-void A_JetgThink(struct mobj_s *actor); // Jetty-Syn Gunner Thinker
-void A_JetgShoot(struct mobj_s *actor); // Jetty-Syn Shoot Function
-void A_ShootBullet(struct mobj_s *actor); // JetgShoot without reactiontime setting
-void A_MinusDigging(struct mobj_s *actor);
-void A_MinusPopup(struct mobj_s *actor);
-void A_MinusCheck(struct mobj_s *actor);
-void A_ChickenCheck(struct mobj_s *actor);
-void A_MouseThink(struct mobj_s *actor); // Mouse Thinker
-void A_DetonChase(struct mobj_s *actor); // Deton Chaser
-void A_CapeChase(struct mobj_s *actor); // Fake little Super Sonic cape
-void A_RotateSpikeBall(struct mobj_s *actor); // Spike ball rotation
-void A_SlingAppear(struct mobj_s *actor);
-void A_UnidusBall(struct mobj_s *actor);
-void A_RockSpawn(struct mobj_s *actor);
-void A_SetFuse(struct mobj_s *actor);
-void A_CrawlaCommanderThink(struct mobj_s *actor); // Crawla Commander
-void A_SmokeTrailer(struct mobj_s *actor);
-void A_RingExplode(struct mobj_s *actor);
-void A_OldRingExplode(struct mobj_s *actor);
-void A_MixUp(struct mobj_s *actor);
-void A_RecyclePowers(struct mobj_s *actor);
-void A_BossScream(struct mobj_s *actor);
-void A_Boss2TakeDamage(struct mobj_s *actor);
-void A_GoopSplat(struct mobj_s *actor);
-void A_Boss2PogoSFX(struct mobj_s *actor);
-void A_Boss2PogoTarget(struct mobj_s *actor);
-void A_EggmanBox(struct mobj_s *actor);
-void A_TurretFire(struct mobj_s *actor);
-void A_SuperTurretFire(struct mobj_s *actor);
-void A_TurretStop(struct mobj_s *actor);
-void A_JetJawRoam(struct mobj_s *actor);
-void A_JetJawChomp(struct mobj_s *actor);
-void A_PointyThink(struct mobj_s *actor);
-void A_CheckBuddy(struct mobj_s *actor);
-void A_HoodFire(struct mobj_s *actor);
-void A_HoodThink(struct mobj_s *actor);
-void A_HoodFall(struct mobj_s *actor);
-void A_ArrowBonks(struct mobj_s *actor);
-void A_SnailerThink(struct mobj_s *actor);
-void A_SharpChase(struct mobj_s *actor);
-void A_SharpSpin(struct mobj_s *actor);
-void A_SharpDecel(struct mobj_s *actor);
-void A_CrushstaceanWalk(struct mobj_s *actor);
-void A_CrushstaceanPunch(struct mobj_s *actor);
-void A_CrushclawAim(struct mobj_s *actor);
-void A_CrushclawLaunch(struct mobj_s *actor);
-void A_VultureVtol(struct mobj_s *actor);
-void A_VultureCheck(struct mobj_s *actor);
-void A_VultureHover(struct mobj_s *actor);
-void A_VultureBlast(struct mobj_s *actor);
-void A_VultureFly(struct mobj_s *actor);
-void A_SkimChase(struct mobj_s *actor);
-void A_SkullAttack(struct mobj_s *actor);
-void A_LobShot(struct mobj_s *actor);
-void A_FireShot(struct mobj_s *actor);
-void A_SuperFireShot(struct mobj_s *actor);
-void A_BossFireShot(struct mobj_s *actor);
-void A_Boss7FireMissiles(struct mobj_s *actor);
-void A_Boss1Laser(struct mobj_s *actor);
-void A_FocusTarget(struct mobj_s *actor);
-void A_Boss4Reverse(struct mobj_s *actor);
-void A_Boss4SpeedUp(struct mobj_s *actor);
-void A_Boss4Raise(struct mobj_s *actor);
-void A_SparkFollow(struct mobj_s *actor);
-void A_BuzzFly(struct mobj_s *actor);
-void A_GuardChase(struct mobj_s *actor);
-void A_EggShield(struct mobj_s *actor);
-void A_SetReactionTime(struct mobj_s *actor);
-void A_Boss1Spikeballs(struct mobj_s *actor);
-void A_Boss3TakeDamage(struct mobj_s *actor);
-void A_Boss3Path(struct mobj_s *actor);
-void A_Boss3ShockThink(struct mobj_s *actor);
-void A_Shockwave(struct mobj_s *actor);
-void A_LinedefExecute(struct mobj_s *actor);
-void A_LinedefExecuteFromArg(struct mobj_s *actor);
-void A_PlaySeeSound(struct mobj_s *actor);
-void A_PlayAttackSound(struct mobj_s *actor);
-void A_PlayActiveSound(struct mobj_s *actor);
-void A_1upThinker(struct mobj_s *actor);
-void A_BossZoom(struct mobj_s *actor); //Unused
-void A_Boss1Chase(struct mobj_s *actor);
-void A_Boss2Chase(struct mobj_s *actor);
-void A_Boss2Pogo(struct mobj_s *actor);
-void A_Boss7Chase(struct mobj_s *actor);
-void A_BossJetFume(struct mobj_s *actor);
-void A_SpawnObjectAbsolute(struct mobj_s *actor);
-void A_SpawnObjectRelative(struct mobj_s *actor);
-void A_ChangeAngleRelative(struct mobj_s *actor);
-void A_ChangeAngleAbsolute(struct mobj_s *actor);
-void A_RollAngle(struct mobj_s *actor);
-void A_ChangeRollAngleRelative(struct mobj_s *actor);
-void A_ChangeRollAngleAbsolute(struct mobj_s *actor);
-void A_PlaySound(struct mobj_s *actor);
-void A_FindTarget(struct mobj_s *actor);
-void A_FindTracer(struct mobj_s *actor);
-void A_SetTics(struct mobj_s *actor);
-void A_SetRandomTics(struct mobj_s *actor);
-void A_ChangeColorRelative(struct mobj_s *actor);
-void A_ChangeColorAbsolute(struct mobj_s *actor);
-void A_Dye(struct mobj_s *actor);
-void A_SetTranslation(struct mobj_s *actor);
-void A_MoveRelative(struct mobj_s *actor);
-void A_MoveAbsolute(struct mobj_s *actor);
-void A_Thrust(struct mobj_s *actor);
-void A_ZThrust(struct mobj_s *actor);
-void A_SetTargetsTarget(struct mobj_s *actor);
-void A_SetObjectFlags(struct mobj_s *actor);
-void A_SetObjectFlags2(struct mobj_s *actor);
-void A_RandomState(struct mobj_s *actor);
-void A_RandomStateRange(struct mobj_s *actor);
-void A_StateRangeByAngle(struct mobj_s *actor);
-void A_StateRangeByParameter(struct mobj_s *actor);
-void A_DualAction(struct mobj_s *actor);
-void A_RemoteAction(struct mobj_s *actor);
-void A_ToggleFlameJet(struct mobj_s *actor);
-void A_OrbitNights(struct mobj_s *actor);
-void A_GhostMe(struct mobj_s *actor);
-void A_SetObjectState(struct mobj_s *actor);
-void A_SetObjectTypeState(struct mobj_s *actor);
-void A_KnockBack(struct mobj_s *actor);
-void A_PushAway(struct mobj_s *actor);
-void A_RingDrain(struct mobj_s *actor);
-void A_SplitShot(struct mobj_s *actor);
-void A_MissileSplit(struct mobj_s *actor);
-void A_MultiShot(struct mobj_s *actor);
-void A_InstaLoop(struct mobj_s *actor);
-void A_Custom3DRotate(struct mobj_s *actor);
-void A_SearchForPlayers(struct mobj_s *actor);
-void A_CheckRandom(struct mobj_s *actor);
-void A_CheckTargetRings(struct mobj_s *actor);
-void A_CheckRings(struct mobj_s *actor);
-void A_CheckTotalRings(struct mobj_s *actor);
-void A_CheckHealth(struct mobj_s *actor);
-void A_CheckRange(struct mobj_s *actor);
-void A_CheckHeight(struct mobj_s *actor);
-void A_CheckTrueRange(struct mobj_s *actor);
-void A_CheckThingCount(struct mobj_s *actor);
-void A_CheckAmbush(struct mobj_s *actor);
-void A_CheckCustomValue(struct mobj_s *actor);
-void A_CheckCusValMemo(struct mobj_s *actor);
-void A_SetCustomValue(struct mobj_s *actor);
-void A_UseCusValMemo(struct mobj_s *actor);
-void A_RelayCustomValue(struct mobj_s *actor);
-void A_CusValAction(struct mobj_s *actor);
-void A_ForceStop(struct mobj_s *actor);
-void A_ForceWin(struct mobj_s *actor);
-void A_SpikeRetract(struct mobj_s *actor);
-void A_InfoState(struct mobj_s *actor);
-void A_Repeat(struct mobj_s *actor);
-void A_SetScale(struct mobj_s *actor);
-void A_RemoteDamage(struct mobj_s *actor);
-void A_HomingChase(struct mobj_s *actor);
-void A_TrapShot(struct mobj_s *actor);
-void A_VileTarget(struct mobj_s *actor);
-void A_VileAttack(struct mobj_s *actor);
-void A_VileFire(struct mobj_s *actor);
-void A_BrakChase(struct mobj_s *actor);
-void A_BrakFireShot(struct mobj_s *actor);
-void A_BrakLobShot(struct mobj_s *actor);
-void A_NapalmScatter(struct mobj_s *actor);
-void A_SpawnFreshCopy(struct mobj_s *actor);
-void A_FlickySpawn(struct mobj_s *actor);
-void A_FlickyCenter(struct mobj_s *actor);
-void A_FlickyAim(struct mobj_s *actor);
-void A_FlickyFly(struct mobj_s *actor);
-void A_FlickySoar(struct mobj_s *actor);
-void A_FlickyCoast(struct mobj_s *actor);
-void A_FlickyHop(struct mobj_s *actor);
-void A_FlickyFlounder(struct mobj_s *actor);
-void A_FlickyCheck(struct mobj_s *actor);
-void A_FlickyHeightCheck(struct mobj_s *actor);
-void A_FlickyFlutter(struct mobj_s *actor);
-void A_FlameParticle(struct mobj_s *actor);
-void A_FadeOverlay(struct mobj_s *actor);
-void A_Boss5Jump(struct mobj_s *actor);
-void A_LightBeamReset(struct mobj_s *actor);
-void A_MineExplode(struct mobj_s *actor);
-void A_MineRange(struct mobj_s *actor);
-void A_ConnectToGround(struct mobj_s *actor);
-void A_SpawnParticleRelative(struct mobj_s *actor);
-void A_MultiShotDist(struct mobj_s *actor);
-void A_WhoCaresIfYourSonIsABee(struct mobj_s *actor);
-void A_ParentTriesToSleep(struct mobj_s *actor);
-void A_CryingToMomma(struct mobj_s *actor);
-void A_CheckFlags2(struct mobj_s *actor);
-void A_Boss5FindWaypoint(struct mobj_s *actor);
-void A_DoNPCSkid(struct mobj_s *actor);
-void A_DoNPCPain(struct mobj_s *actor);
-void A_PrepareRepeat(struct mobj_s *actor);
-void A_Boss5ExtraRepeat(struct mobj_s *actor);
-void A_Boss5Calm(struct mobj_s *actor);
-void A_Boss5CheckOnGround(struct mobj_s *actor);
-void A_Boss5CheckFalling(struct mobj_s *actor);
-void A_Boss5PinchShot(struct mobj_s *actor);
-void A_Boss5MakeItRain(struct mobj_s *actor);
-void A_Boss5MakeJunk(struct mobj_s *actor);
-void A_LookForBetter(struct mobj_s *actor);
-void A_Boss5BombExplode(struct mobj_s *actor);
-void A_DustDevilThink(struct mobj_s *actor);
-void A_TNTExplode(struct mobj_s *actor);
-void A_DebrisRandom(struct mobj_s *actor);
-void A_TrainCameo(struct mobj_s *actor);
-void A_TrainCameo2(struct mobj_s *actor);
-void A_CanarivoreGas(struct mobj_s *actor);
-void A_KillSegments(struct mobj_s *actor);
-void A_SnapperSpawn(struct mobj_s *actor);
-void A_SnapperThinker(struct mobj_s *actor);
-void A_SaloonDoorSpawn(struct mobj_s *actor);
-void A_MinecartSparkThink(struct mobj_s *actor);
-void A_ModuloToState(struct mobj_s *actor);
-void A_LavafallRocks(struct mobj_s *actor);
-void A_LavafallLava(struct mobj_s *actor);
-void A_FallingLavaCheck(struct mobj_s *actor);
-void A_FireShrink(struct mobj_s *actor);
-void A_SpawnPterabytes(struct mobj_s *actor);
-void A_PterabyteHover(struct mobj_s *actor);
-void A_RolloutSpawn(struct mobj_s *actor);
-void A_RolloutRock(struct mobj_s *actor);
-void A_DragonbomberSpawn(struct mobj_s *actor);
-void A_DragonWing(struct mobj_s *actor);
-void A_DragonSegment(struct mobj_s *actor);
-void A_ChangeHeight(struct mobj_s *actor);
+void A_Explode(void *actor);
+void A_Pain(void *actor);
+void A_Fall(void *actor);
+void A_MonitorPop(void *actor);
+void A_GoldMonitorPop(void *actor);
+void A_GoldMonitorRestore(void *actor);
+void A_GoldMonitorSparkle(void *actor);
+void A_Look(void *actor);
+void A_Chase(void *actor);
+void A_FaceStabChase(void *actor);
+void A_FaceStabRev(void *actor);
+void A_FaceStabHurl(void *actor);
+void A_FaceStabMiss(void *actor);
+void A_StatueBurst(void *actor);
+void A_FaceTarget(void *actor);
+void A_FaceTracer(void *actor);
+void A_Scream(void *actor);
+void A_BossDeath(void *actor);
+void A_SetShadowScale(void *actor);
+void A_ShadowScream(void *actor); // MARIA!!!!!!
+void A_CustomPower(void *actor); // Use this for a custom power
+void A_GiveWeapon(void *actor); // Gives the player weapon(s)
+void A_RingBox(void *actor); // Obtained Ring Box Tails
+void A_Invincibility(void *actor); // Obtained Invincibility Box
+void A_SuperSneakers(void *actor); // Obtained Super Sneakers Box
+void A_BunnyHop(void *actor); // have bunny hop tails
+void A_BubbleSpawn(void *actor); // Randomly spawn bubbles
+void A_FanBubbleSpawn(void *actor);
+void A_BubbleRise(void *actor); // Bubbles float to surface
+void A_BubbleCheck(void *actor); // Don't draw if not underwater
+void A_AwardScore(void *actor);
+void A_ExtraLife(void *actor); // Extra Life
+void A_GiveShield(void *actor); // Obtained Shield
+void A_GravityBox(void *actor);
+void A_ScoreRise(void *actor); // Rise the score logo
+void A_AttractChase(void *actor); // Ring Chase
+void A_DropMine(void *actor); // Drop Mine from Skim or Jetty-Syn Bomber
+void A_FishJump(void *actor); // Fish Jump
+void A_ThrownRing(void *actor); // Sparkle trail for red ring
+void A_SetSolidSteam(void *actor);
+void A_UnsetSolidSteam(void *actor);
+void A_SignSpin(void *actor);
+void A_SignPlayer(void *actor);
+void A_OverlayThink(void *actor);
+void A_JetChase(void *actor);
+void A_JetbThink(void *actor); // Jetty-Syn Bomber Thinker
+void A_JetgThink(void *actor); // Jetty-Syn Gunner Thinker
+void A_JetgShoot(void *actor); // Jetty-Syn Shoot Function
+void A_ShootBullet(void *actor); // JetgShoot without reactiontime setting
+void A_MinusDigging(void *actor);
+void A_MinusPopup(void *actor);
+void A_MinusCheck(void *actor);
+void A_ChickenCheck(void *actor);
+void A_MouseThink(void *actor); // Mouse Thinker
+void A_DetonChase(void *actor); // Deton Chaser
+void A_CapeChase(void *actor); // Fake little Super Sonic cape
+void A_RotateSpikeBall(void *actor); // Spike ball rotation
+void A_SlingAppear(void *actor);
+void A_UnidusBall(void *actor);
+void A_RockSpawn(void *actor);
+void A_SetFuse(void *actor);
+void A_CrawlaCommanderThink(void *actor); // Crawla Commander
+void A_SmokeTrailer(void *actor);
+void A_RingExplode(void *actor);
+void A_OldRingExplode(void *actor);
+void A_MixUp(void *actor);
+void A_RecyclePowers(void *actor);
+void A_BossScream(void *actor);
+void A_Boss2TakeDamage(void *actor);
+void A_GoopSplat(void *actor);
+void A_Boss2PogoSFX(void *actor);
+void A_Boss2PogoTarget(void *actor);
+void A_EggmanBox(void *actor);
+void A_TurretFire(void *actor);
+void A_SuperTurretFire(void *actor);
+void A_TurretStop(void *actor);
+void A_JetJawRoam(void *actor);
+void A_JetJawChomp(void *actor);
+void A_PointyThink(void *actor);
+void A_CheckBuddy(void *actor);
+void A_HoodFire(void *actor);
+void A_HoodThink(void *actor);
+void A_HoodFall(void *actor);
+void A_ArrowBonks(void *actor);
+void A_SnailerThink(void *actor);
+void A_SharpChase(void *actor);
+void A_SharpSpin(void *actor);
+void A_SharpDecel(void *actor);
+void A_CrushstaceanWalk(void *actor);
+void A_CrushstaceanPunch(void *actor);
+void A_CrushclawAim(void *actor);
+void A_CrushclawLaunch(void *actor);
+void A_VultureVtol(void *actor);
+void A_VultureCheck(void *actor);
+void A_VultureHover(void *actor);
+void A_VultureBlast(void *actor);
+void A_VultureFly(void *actor);
+void A_SkimChase(void *actor);
+void A_SkullAttack(void *actor);
+void A_LobShot(void *actor);
+void A_FireShot(void *actor);
+void A_SuperFireShot(void *actor);
+void A_BossFireShot(void *actor);
+void A_Boss7FireMissiles(void *actor);
+void A_Boss1Laser(void *actor);
+void A_FocusTarget(void *actor);
+void A_Boss4Reverse(void *actor);
+void A_Boss4SpeedUp(void *actor);
+void A_Boss4Raise(void *actor);
+void A_SparkFollow(void *actor);
+void A_BuzzFly(void *actor);
+void A_GuardChase(void *actor);
+void A_EggShield(void *actor);
+void A_SetReactionTime(void *actor);
+void A_Boss1Spikeballs(void *actor);
+void A_Boss3TakeDamage(void *actor);
+void A_Boss3Path(void *actor);
+void A_Boss3ShockThink(void *actor);
+void A_Shockwave(void *actor);
+void A_LinedefExecute(void *actor);
+void A_LinedefExecuteFromArg(void *actor);
+void A_PlaySeeSound(void *actor);
+void A_PlayAttackSound(void *actor);
+void A_PlayActiveSound(void *actor);
+void A_1upThinker(void *actor);
+void A_BossZoom(void *actor); //Unused
+void A_Boss1Chase(void *actor);
+void A_Boss2Chase(void *actor);
+void A_Boss2Pogo(void *actor);
+void A_Boss7Chase(void *actor);
+void A_BossJetFume(void *actor);
+void A_SpawnObjectAbsolute(void *actor);
+void A_SpawnObjectRelative(void *actor);
+void A_ChangeAngleRelative(void *actor);
+void A_ChangeAngleAbsolute(void *actor);
+void A_RollAngle(void *actor);
+void A_ChangeRollAngleRelative(void *actor);
+void A_ChangeRollAngleAbsolute(void *actor);
+void A_PlaySound(void *actor);
+void A_FindTarget(void *actor);
+void A_FindTracer(void *actor);
+void A_SetTics(void *actor);
+void A_SetRandomTics(void *actor);
+void A_ChangeColorRelative(void *actor);
+void A_ChangeColorAbsolute(void *actor);
+void A_Dye(void *actor);
+void A_SetTranslation(void *actor);
+void A_MoveRelative(void *actor);
+void A_MoveAbsolute(void *actor);
+void A_Thrust(void *actor);
+void A_ZThrust(void *actor);
+void A_SetTargetsTarget(void *actor);
+void A_SetObjectFlags(void *actor);
+void A_SetObjectFlags2(void *actor);
+void A_RandomState(void *actor);
+void A_RandomStateRange(void *actor);
+void A_StateRangeByAngle(void *actor);
+void A_StateRangeByParameter(void *actor);
+void A_DualAction(void *actor);
+void A_RemoteAction(void *actor);
+void A_ToggleFlameJet(void *actor);
+void A_OrbitNights(void *actor);
+void A_GhostMe(void *actor);
+void A_SetObjectState(void *actor);
+void A_SetObjectTypeState(void *actor);
+void A_KnockBack(void *actor);
+void A_PushAway(void *actor);
+void A_RingDrain(void *actor);
+void A_SplitShot(void *actor);
+void A_MissileSplit(void *actor);
+void A_MultiShot(void *actor);
+void A_InstaLoop(void *actor);
+void A_Custom3DRotate(void *actor);
+void A_SearchForPlayers(void *actor);
+void A_CheckRandom(void *actor);
+void A_CheckTargetRings(void *actor);
+void A_CheckRings(void *actor);
+void A_CheckTotalRings(void *actor);
+void A_CheckHealth(void *actor);
+void A_CheckRange(void *actor);
+void A_CheckHeight(void *actor);
+void A_CheckTrueRange(void *actor);
+void A_CheckThingCount(void *actor);
+void A_CheckAmbush(void *actor);
+void A_CheckCustomValue(void *actor);
+void A_CheckCusValMemo(void *actor);
+void A_SetCustomValue(void *actor);
+void A_UseCusValMemo(void *actor);
+void A_RelayCustomValue(void *actor);
+void A_CusValAction(void *actor);
+void A_ForceStop(void *actor);
+void A_ForceWin(void *actor);
+void A_SpikeRetract(void *actor);
+void A_InfoState(void *actor);
+void A_Repeat(void *actor);
+void A_SetScale(void *actor);
+void A_RemoteDamage(void *actor);
+void A_HomingChase(void *actor);
+void A_TrapShot(void *actor);
+void A_VileTarget(void *actor);
+void A_VileAttack(void *actor);
+void A_VileFire(void *actor);
+void A_BrakChase(void *actor);
+void A_BrakFireShot(void *actor);
+void A_BrakLobShot(void *actor);
+void A_NapalmScatter(void *actor);
+void A_SpawnFreshCopy(void *actor);
+void A_FlickySpawn(void *actor);
+void A_FlickyCenter(void *actor);
+void A_FlickyAim(void *actor);
+void A_FlickyFly(void *actor);
+void A_FlickySoar(void *actor);
+void A_FlickyCoast(void *actor);
+void A_FlickyHop(void *actor);
+void A_FlickyFlounder(void *actor);
+void A_FlickyCheck(void *actor);
+void A_FlickyHeightCheck(void *actor);
+void A_FlickyFlutter(void *actor);
+void A_FlameParticle(void *actor);
+void A_FadeOverlay(void *actor);
+void A_Boss5Jump(void *actor);
+void A_LightBeamReset(void *actor);
+void A_MineExplode(void *actor);
+void A_MineRange(void *actor);
+void A_ConnectToGround(void *actor);
+void A_SpawnParticleRelative(void *actor);
+void A_MultiShotDist(void *actor);
+void A_WhoCaresIfYourSonIsABee(void *actor);
+void A_ParentTriesToSleep(void *actor);
+void A_CryingToMomma(void *actor);
+void A_CheckFlags2(void *actor);
+void A_Boss5FindWaypoint(void *actor);
+void A_DoNPCSkid(void *actor);
+void A_DoNPCPain(void *actor);
+void A_PrepareRepeat(void *actor);
+void A_Boss5ExtraRepeat(void *actor);
+void A_Boss5Calm(void *actor);
+void A_Boss5CheckOnGround(void *actor);
+void A_Boss5CheckFalling(void *actor);
+void A_Boss5PinchShot(void *actor);
+void A_Boss5MakeItRain(void *actor);
+void A_Boss5MakeJunk(void *actor);
+void A_LookForBetter(void *actor);
+void A_Boss5BombExplode(void *actor);
+void A_DustDevilThink(void *actor);
+void A_TNTExplode(void *actor);
+void A_DebrisRandom(void *actor);
+void A_TrainCameo(void *actor);
+void A_TrainCameo2(void *actor);
+void A_CanarivoreGas(void *actor);
+void A_KillSegments(void *actor);
+void A_SnapperSpawn(void *actor);
+void A_SnapperThinker(void *actor);
+void A_SaloonDoorSpawn(void *actor);
+void A_MinecartSparkThink(void *actor);
+void A_ModuloToState(void *actor);
+void A_LavafallRocks(void *actor);
+void A_LavafallLava(void *actor);
+void A_FallingLavaCheck(void *actor);
+void A_FireShrink(void *actor);
+void A_SpawnPterabytes(void *actor);
+void A_PterabyteHover(void *actor);
+void A_RolloutSpawn(void *actor);
+void A_RolloutRock(void *actor);
+void A_DragonbomberSpawn(void *actor);
+void A_DragonWing(void *actor);
+void A_DragonSegment(void *actor);
+void A_ChangeHeight(void *actor);
 
 extern int actionsoverridden[NUMACTIONS][MAX_ACTION_RECURSION];
 
@@ -4410,7 +4410,7 @@ typedef struct
 	spritenum_t sprite;
 	UINT32 frame; // we use the upper 16 bits for translucency and other shade effects
 	INT32 tics;
-	actionf_t action;
+	actionf_p1 action;
 	INT32 var1;
 	INT32 var2;
 	statenum_t nextstate;
diff --git a/src/lua_infolib.c b/src/lua_infolib.c
index a65ee23ebc..44a74b7878 100644
--- a/src/lua_infolib.c
+++ b/src/lua_infolib.c
@@ -714,21 +714,19 @@ static int lib_setState(lua_State *L)
 			switch(lua_type(L, 3))
 			{
 			case LUA_TNIL: // Null? Set the action to nothing, then.
-				state->action.acp1 = NULL;
+				state->action = NULL;
 				break;
 			case LUA_TSTRING: // It's a string, expect the name of a built-in action
 				LUA_SetActionByName(state, lua_tostring(L, 3));
 				break;
 			case LUA_TUSERDATA: // It's a userdata, expect META_ACTION of a built-in action
 			{
-				actionf_t *action = *((actionf_t **)luaL_checkudata(L, 3, META_ACTION));
+				actionf_p1 *action = *((actionf_p1 **)luaL_checkudata(L, 3, META_ACTION));
 
 				if (!action)
 					return luaL_error(L, "not a valid action?");
 
 				state->action = *action;
-				state->action.acv = action->acv;
-				state->action.acp1 = action->acp1;
 				break;
 			}
 			case LUA_TFUNCTION: // It's a function (a Lua function or a C function? either way!)
@@ -738,7 +736,7 @@ static int lib_setState(lua_State *L)
 				lua_pushvalue(L, 3); // Bring it to the top of the stack
 				lua_rawset(L, -3); // Set it in the registry
 				lua_pop(L, 1); // pop LREG_STATEACTION
-				state->action.acp1 = (actionf_p1)A_Lua; // Set the action for the userdata.
+				state->action = (actionf_p1)A_Lua; // Set the action for the userdata.
 				break;
 			default: // ?!
 				return luaL_typerror(L, 3, "function");
@@ -796,7 +794,7 @@ boolean LUA_SetLuaAction(void *stv, const char *action)
 	lua_pop(gL, 1); // pop LREG_STATEACTION
 
 	lua_pop(gL, 2); // pop the function and LREG_ACTIONS
-	st->action.acp1 = (actionf_p1)A_Lua; // Set the action for the userdata.
+	st->action = (actionf_p1)A_Lua; // Set the action for the userdata.
 	return true; // action successfully set.
 }
 
@@ -901,9 +899,9 @@ static int state_get(lua_State *L)
 		number = st->tics;
 	else if (fastcmp(field,"action")) {
 		const char *name;
-		if (!st->action.acp1) // Action is NULL.
+		if (!st->action) // Action is NULL.
 			return 0; // return nil.
-		if (st->action.acp1 == (actionf_p1)A_Lua) { // This is a Lua function?
+		if (st->action == (actionf_p1)A_Lua) { // This is a Lua function?
 			lua_getfield(L, LUA_REGISTRYINDEX, LREG_STATEACTION);
 			I_Assert(lua_istable(L, -1));
 			lua_pushlightuserdata(L, st); // Push the state pointer and
@@ -958,21 +956,19 @@ static int state_set(lua_State *L)
 		switch(lua_type(L, 3))
 		{
 		case LUA_TNIL: // Null? Set the action to nothing, then.
-			st->action.acp1 = NULL;
+			st->action = NULL;
 			break;
 		case LUA_TSTRING: // It's a string, expect the name of a built-in action
 			LUA_SetActionByName(st, lua_tostring(L, 3));
 			break;
 		case LUA_TUSERDATA: // It's a userdata, expect META_ACTION of a built-in action
 		{
-			actionf_t *action = *((actionf_t **)luaL_checkudata(L, 3, META_ACTION));
+			actionf_p1 *action = *((actionf_p1 **)luaL_checkudata(L, 3, META_ACTION));
 
 			if (!action)
 				return luaL_error(L, "not a valid action?");
 
 			st->action = *action;
-			st->action.acv = action->acv;
-			st->action.acp1 = action->acp1;
 			break;
 		}
 		case LUA_TFUNCTION: // It's a function (a Lua function or a C function? either way!)
@@ -982,7 +978,7 @@ static int state_set(lua_State *L)
 			lua_pushvalue(L, 3); // Bring it to the top of the stack
 			lua_rawset(L, -3); // Set it in the registry
 			lua_pop(L, 1); // pop LREG_STATEACTION
-			st->action.acp1 = (actionf_p1)A_Lua; // Set the action for the userdata.
+			st->action = (actionf_p1)A_Lua; // Set the action for the userdata.
 			break;
 		default: // ?!
 			return luaL_typerror(L, 3, "function");
diff --git a/src/lua_thinkerlib.c b/src/lua_thinkerlib.c
index f1be8c7893..1701b89ddc 100644
--- a/src/lua_thinkerlib.c
+++ b/src/lua_thinkerlib.c
@@ -44,7 +44,7 @@ static int iterationState_gc(lua_State *L)
 }
 
 #define push_thinker(th) {\
-	if ((th)->function.acp1 == (actionf_p1)P_MobjThinker) \
+	if ((th)->function == (actionf_p1)P_MobjThinker) \
 		LUA_PushUserdata(L, (th), META_MOBJ); \
 	else \
 		lua_pushlightuserdata(L, (th)); \
@@ -93,7 +93,7 @@ static int lib_iterateThinkers(lua_State *L)
 		return luaL_error(L, "next thinker invalidated during iteration");
 
 	for (; next != &thlist[THINK_MOBJ]; next = next->next)
-		if (!it->filter || next->function.acp1 == it->filter)
+		if (!it->filter || next->function == it->filter)
 		{
 			push_thinker(next);
 			if (next->next != &thlist[THINK_MOBJ])
diff --git a/src/m_perfstats.c b/src/m_perfstats.c
index 33a774acfb..54490e469c 100644
--- a/src/m_perfstats.c
+++ b/src/m_perfstats.c
@@ -592,7 +592,7 @@ static void PS_CountThinkers(void)
 				ps_mainthcount.value.i++;
 			else if (i == THINK_MOBJ)
 			{
-				if (thinker->function.acp1 == (actionf_p1)P_MobjThinker)
+				if (thinker->function == (actionf_p1)P_MobjThinker)
 				{
 					mobj_t *mobj = (mobj_t*)thinker;
 					ps_mobjcount.value.i++;
diff --git a/src/netcode/d_netcmd.c b/src/netcode/d_netcmd.c
index 94170fa0df..6353832ef7 100644
--- a/src/netcode/d_netcmd.c
+++ b/src/netcode/d_netcmd.c
@@ -4811,7 +4811,7 @@ static void Command_Archivetest_f(void)
 	// assign mobjnum
 	i = 1;
 	for (th = thlist[THINK_MOBJ].next; th != &thlist[THINK_MOBJ]; th = th->next)
-		if (th->function.acp1 != (actionf_p1)P_RemoveThinkerDelayed)
+		if (th->function != (actionf_p1)P_RemoveThinkerDelayed)
 			((mobj_t *)th)->mobjnum = i++;
 
 	// allocate buffer
